-- UPDATE 07.11.2016. netflow.bulk_aggregate_top_n se menja da ima 2 topN parametra
CREATE OR REPLACE FUNCTION netflow.bulk_aggregate_top_n(
    srcsuffix text,
    srcgrain text,
    dstsuffix text,
    dstgrain text,
    t1 timestamp without time zone,
    t2 timestamp without time zone)
  RETURNS void AS
$BODY$
DECLARE
	topnuserhost integer;
    topnuserconversation integer;
BEGIN
  PERFORM netflow.bulk_agg_exporter_device_total(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_device_as(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_device_conversation(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_device_host(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_device_protocol(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_device_qos(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_device_service(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);

  PERFORM netflow.bulk_agg_exporter_interface_total(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_interface_as(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_interface_conversation(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_interface_host(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_interface_protocol(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_interface_qos(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_exporter_interface_service(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);

  PERFORM netflow.bulk_agg_pattern_subnet_total(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_pattern_subnet_as(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_pattern_subnet_conversation(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_pattern_subnet_host(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_pattern_subnet_protocol(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_pattern_subnet_qos(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_pattern_subnet_service(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);

  /*
   * Pronadje se najveci TopN za host i converzacije za user, 
   * jer "ne moze" da se radi po useru pa se ovako postize korektnost podataka 
   */
  SELECT MAX(topn)
  INTO topnuserconversation
  FROM (
	SELECT cast( substring(value from 'CONVERSATION\((\d+)\)') as int) as topn
	FROM netflow_conf.counter_config
	WHERE type = 'END_USER' AND value LIKE '%CONVERSATION%'
	
	UNION  
	
	SELECT MAX(top_conversation) as topn
	FROM netflow_conf.default_config
	WHERE type = 'END_USER'
  ) as sub;
  
  SELECT MAX(topn)
  INTO topnuserhost
  FROM (
	SELECT MAX(cast( substring(value from 'HOST\((\d+)\)') as int)) as topn
	FROM netflow_conf.counter_config
	WHERE type = 'END_USER' AND value LIKE '%HOST%'

	UNION  
  
	SELECT MAX(top_host) as topn
	FROM netflow_conf.default_config
	WHERE type = 'END_USER'
  ) as sub;
    
  PERFORM netflow.bulk_agg_user_mapping_total(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_user_mapping_host_top_n(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2,topnuserhost);
  PERFORM netflow.bulk_agg_user_mapping_service(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_user_mapping_protocol(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_user_mapping_as(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_user_mapping_qos(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2);
  PERFORM netflow.bulk_agg_user_mapping_conversation_top_n(srcsuffix,srcgrain,dstsuffix,dstgrain,t1,t2,topnuserconversation);
END;
$BODY$
  LANGUAGE plpgsql VOLATILE STRICT
  COST 100;
ALTER FUNCTION netflow.bulk_aggregate_top_n(text, text, text, text, timestamp without time zone, timestamp without time zone, integer)
  OWNER TO postgres; 

-- END UPDATE 07.11.2016.

-- UPDATE 14.11.2016. Unique Constraint for device_type NVDEV-488

CREATE TABLE temp_device_device_type (
	id_device integer NOT NULL,
	id_device_type integer NOT NULL
);

INSERT INTO temp_device_device_type
	SELECT DISTINCT * FROM typology.device_device_type;

DELETE FROM typology.device_device_type;

INSERT INTO typology.device_device_type
	SELECT * FROM temp_device_device_type;

DROP TABLE temp_device_device_type;

ALTER TABLE typology.device_device_type
	ADD CONSTRAINT uq_device_device_type UNIQUE (id_device, id_device_type);

-- END UPDATE 31.10.2016.
  
INSERT INTO framework.db_version(patch_number, patch_date) VALUES (61, current_timestamp);